require "src/button"
function love.load()
    SCREEN_WIDTH = 1280
    SCREEN_HEIGHT = 780
    RES = 10

    canPlace = true 

    WIDTH = SCREEN_WIDTH / RES
    HEIGHT = SCREEN_HEIGHT / RES
    


    time = 0
    fps = 0
    desFps = 20
    gen = 0
    lastgen = 0
    amountPerFrame = 100

    vInput = ""
    button_x = 2
    buttons = {}
    b = button.new(button_x, 0, 100, 30, "Pause", "pause")
    table.insert(buttons, b)
    b = button.new(button_x, 32, 100, 30, "=>", "nextGen")
    table.insert(buttons, b)
    b = button.new(button_x, 64, 100, 30, "Randomize", "random")
    table.insert(buttons, b)
    b = button.new(button_x, 64 + 32, 100, 30, "Clear", "clear")
    table.insert(buttons, b)
    b = button.new(button_x + 102, 1, 10, 31 * 4, "<", "hide")
    table.insert(buttons, b)
    hidden = false 

    button_x = 0

    font = love.graphics.setNewFont(16)

    grid = {}
    empty = {}
    pause = true
    for y=0, HEIGHT do 
        grid[y] = {}
        empty[y] = {}
        for x=0, WIDTH do 
            grid[y][x] = 0
            empty[y][x] = 0
        end
    end
    newGen = empty
    love.graphics.setBackgroundColor(1,1, 1)
end

function love.update(dt)
    if pause == false then
        gen = gen + 1
    end
    if gen > lastgen then 
        lastgen = gen
        produceNextGen()
    end
    touchInput()
    for i, b in ipairs(buttons) do 
        b:update()
    end
    if hidden == true then
       button_x = -100
    else
        button_x = 0 
    end
end



function love.draw()
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            if value == 1 then 
                if pause == true then
                    love.graphics.setColor(1, 0.2, 0.2)
                else
                    love.graphics.setColor(0, 0, 0)
                end
                love.graphics.rectangle("fill", (x-1) * RES, (y-1) * RES, RES, RES)
            end
        end
    end
    love.graphics.setColor(0, 0, 0)
    for i, b in ipairs(buttons) do 
        b:draw()
    end
end

function touchInput()
    if vInput == "pause" then
        canPlace = true
        vInput = ""
        if pause == true then 
            pause = false
        else 
            pause = true
        end
    end
    if vInput == "hide" then 
        canPlace = true
        vInput = ""
        if hidden == true then 
            hidden = false
        else
            hidden = true
        end
    end
    if vInput == "nextGen" and pause == true then 
        gen = gen + 1
        canPlace = true
        vInput = ""
    end
    if vInput == "random" then
        canPlace = true
        vInput = "" 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                local ran = love.math.random(0, 1) 
                if x > 1 and x < WIDTH and y > 1 and y < HEIGHT then 
                    grid[y][x] = ran
                    newGen[y][x] = ran
                else 
                    grid[y][x] = 0
                    newGen[y][x] = 0
                end
            end
        end
    end
    if vInput == "clear" then
        canPlace = true
        vInput = "" 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                grid[y][x] = 0
                newGen[y][x] = 0
            end
        end
    end
end

function love.keypressed(key)
    --allows to evolve the next gen in pause mode
    if key == "w" and pause == true then 
        gen = gen + 1
    end
    --randomizes the board
    if key == "r" then 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                local ran = love.math.random(0, 1) 
                if x > 1 and x < WIDTH and y > 1 and y < HEIGHT then 
                    grid[y][x] = ran
                    newGen[y][x] = ran
                else 
                    grid[y][x] = 0
                    newGen[y][x] = 0
                end
            end
        end
    end
    --wipes/cleans the board (all cells are now dead)
    if key == "c" then 
        for y=0, HEIGHT do 
            grid[y] = {}
            newGen[y] = {}
            for x=0, WIDTH do
                grid[y][x] = 0
                newGen[y][x] = 0
            end
        end
    end
    --sets pause on or of
    if key == "space" then 
        if pause == true then 
            pause = false
        else 
            pause = true
        end
    end
end

function love.mousepressed(x, y, button)
    for i, b in ipairs(buttons) do 
        b:press(x, y, button)
    end
    --lets you change cell state at the mouse coordinate
    if love.mouse.isDown(1) and canPlace == true then 
        local x, y = math.ceil(x/RES), math.ceil(y/RES)
        if x > 1 and x < WIDTH and y > 1 and y < HEIGHT then 
            if grid[y][x] == 1 then 
                grid[y][x] = 0
                newGen[y][x] = 0
            else
                grid[y][x] = 1
                newGen[y][x] = 1
            end
        end
    end
    
end


function produceNextGen(X, Y,value)
    --newGen gets cleared
    newGen = empty
    for y, xs in ipairs(empty) do 
        for x, value in ipairs(xs) do 
            newGen[y][x] = empty[y][x]
        end
    end

    --counts the neighboors and decides wether a cell will be dead or alive in the next generation
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            local totalN = 0
            if x > 1 and x < WIDTH and y > 1 and y < HEIGHT then 
                if grid[y - 1][x] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y + 1][x] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y][x - 1] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y][x + 1] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y- 1][x - 1] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y + 1][x + 1] == 1 then 
                    totalN =totalN + 1
                end
                if grid[y + 1][x - 1] == 1 then 
                    totalN = totalN + 1
                end
                if grid[y - 1][x + 1] ==  1 then 
                    totalN = totalN + 1
                end
                if value == 1 then 
                    if totalN > 3 then --death by overpopulation default: >3
                        newGen[y][x] = 0
                    elseif totalN < 2 then --death by underpopulation defaul: <2
                        newGen[y][x] = 0
                    else---stays alive when above isnt true
                        newGen[y][x] = 1
                    end
                end
                if value == 0 then 
                    if totalN == 3 then --birth default: == 3
                        newGen[y][x] = 1
                    end
                end
            end           
        end
    end
    --assigns each x and y of the newgen to the grid table
    for y, xs in ipairs(grid) do 
        for x, value in ipairs(xs) do 
            grid[y][x] = newGen[y][x]
        end
    end

end



